=== debian/control ===
Source: gpsbabel
Section: utils
Priority: optional
Maintainer: Debian GPS team <gpsbabel@packages.debian.org>
Uploaders: Bernd Zeimetz <bzed@debian.org>, Jochen Sprickerhof <jspricke@debian.org>
Build-Depends: debhelper-compat (= 13),
 pkg-config,
 libexpat1-dev, expat,
 libxml2-utils,
 libusb-1.0-0-dev, zlib1g-dev,
 libshp-dev,
 qtbase5-dev,
 qtwebengine5-dev [amd64 arm64 armhf i386 mipsel],
 qttools5-dev-tools,
 imagemagick,
 locales-all,
 xsltproc,
 docbook-xsl
Build-Depends-Indep: fop, docbook-xml, libpaper-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: http://www.gpsbabel.org/
Vcs-Git: https://salsa.debian.org/debian-gps-team/pkg-gpsbabel.git
Vcs-Browser: https://salsa.debian.org/debian-gps-team/pkg-gpsbabel

Package: gpsbabel
Architecture: any
Recommends: gpsbabel-doc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GPS file conversion plus transfer to/from GPS units
 GPSBabel converts waypoints, tracks, and routes from one format to
 another, whether that format is a common mapping format like Delorme,
 Streets and Trips, or even a serial upload or download to a GPS unit
 such as those from Garmin and Magellan.
 .
 GPSBabel supports dozens of data formats and will be useful for tasks
 such as geocaching, mapping, and converting from one GPS unit to another.
 Among the interesting formats it supports are several GPS devices via
 a serial link, various PDA-based mapping programs, and various
 Geocaching data formats.
 .
 Among others GPSBabel supports the following formats:
 .
 Cetus, CoPilot Flight Planner, CSV, Custom CSV, Delorme Street Atlas,
 Delorme Street Atlas 2004 Plus, Delorms GPS Log, Delorme routes,
 DNA, EasyGPS Binary, Fugawi, Garmin serial, Geocaching.com loc,
 GeocachingDB, Geoniche, GPilotS, GPSDrive, GPSman, GPSPilot,
 gpsutil, GPX, Holux, IGC, Magellan serial, Magellan SD,
 Magellan Navigator Companion, Mapopolis.Com Mapconverter, Mapsend,
 Mapsource, Maptech, Microsoft Streets and Trips, Navicache,
 Netstumbler, NIMA/GNIS Geographic Names, NMEA sentences, OziExplorer,
 PalmDoc, PCX5, PocketStreets 2002 Pushpin, PSITrex, Quovadis,
 Tab-separated data, Tiger, TopoMapPro, Topo by National Geographic,
 xcsv, xmap, xmapwpt.

Package: gpsbabel-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: gpsbabel, pdf-viewer | www-browser
Description: GPS file conversion plus transfer to/from GPS units - documentation
 GPSBabel converts waypoints, tracks, and routes from one format to
 another, whether that format is a common mapping format like Delorme,
 Streets and Trips, or even a serial upload or download to a GPS unit
 such as those from Garmin and Magellan.
 .
 GPSBabel supports dozens of data formats and will be useful for tasks
 such as geocaching, mapping, and converting from one GPS unit to another.
 Among the interesting formats it supports are several GPS devices via
 a serial link, various PDA-based mapping programs, and various
 Geocaching data formats.
 .
 This package contains the detailed documentation of gpsbabel.

Package: gpsbabel-gui
Architecture: amd64 arm64 armhf i386 mipsel
Depends: ${shlibs:Depends}, ${misc:Depends}, gpsbabel (= ${binary:Version})
Description: GPS file conversion plus transfer to/from GPS units - GUI
 GPSBabel converts waypoints, tracks, and routes from one format to
 another, whether that format is a common mapping format like Delorme,
 Streets and Trips, or even a serial upload or download to a GPS unit
 such as those from Garmin and Magellan.
 .
 This package contains gpsbabelfe, a QT based frontend for gpsbabel.
