=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT := qt5

%:
	dh $@

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# tests depending on a TZ with a small offset
export TZ='/usr/share/zoneinfo/Etc/GMT'
DOCTEMP = $(CURDIR)/debian/doctmp
include /usr/share/dpkg/pkg-info.mk

# Extended precision on i386 results in weird bugs, so we build
# with -ffloat-store.
ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
CFLAGS += -ffloat-store
endif

override_dh_auto_configure:
	dh_auto_configure -- \
		--with-zlib=system \
		--with-doc=$(DOCTEMP) \
		--prefix=/usr
	convert -resize 32x32 gui/images/appicon.png debian/gpsbabel.xpm
	xsltproc --output debian/gpsbabel.1 /usr/share/xml/docbook/stylesheet/docbook-xsl/manpages/docbook.xsl xmldoc/gpsbabel_man.xml

override_dh_auto_build-arch:
	dh_auto_build
	if dpkg -s qtwebengine5-dev; then $(MAKE) gui; fi

override_dh_auto_build-indep:
	$(MAKE) doc
	$(MAKE) gpsbabel.html
