=== debian/changelog ===
gpsbabel (1.8.0+ds-5) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

  [ Jochen Sprickerhof ]
  * Add upstream source
  * Add workaround for failing lconvert (Closes: #1013610)
  * Bump policy version (no changes)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 25 Jun 2022 21:49:08 +0200

gpsbabel (1.8.0+ds-4) unstable; urgency=medium

  * Drop gmapbase.html (embedded in gpsbabelfe)
  * Fix HTML documentation.
    Thanks to tsteven4

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 25 Jan 2022 23:19:17 +0100

gpsbabel (1.8.0+ds-3) unstable; urgency=medium

  * Add qttranslations5-l10n to -gui
  * Add support for Hurd

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 24 Jan 2022 16:09:49 +0100

gpsbabel (1.8.0+ds-2) unstable; urgency=medium

  * Add patch for failing test on i386
  * Use Debian build flags for the GUI

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 23 Jan 2022 22:24:45 +0100

gpsbabel (1.8.0+ds-1) unstable; urgency=medium

  * Update Files-Excluded for new upstream version
  * New upstream version
  * Rebase patches
  * Update copyright
  * Port to qmake
  * Bump policy versions (no changes)
  * Update build systems of gpsbabel-gui
  * Update supported formats
  * Drop trailing whitespace to please lintian
  * Add missing build dependency
  * Support translated gui
  * Add patch for donation nagging

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 23 Jan 2022 21:25:59 +0100
