=== debian/control ===
--- 
+++ 
@@ -4,22 +4,25 @@
 Maintainer: Debian GPS team <gpsbabel@packages.debian.org>
 Uploaders: Bernd Zeimetz <bzed@debian.org>, Jochen Sprickerhof <jspricke@debian.org>
 Build-Depends: debhelper-compat (= 13),
+ qt5-qmake,
  pkg-config,
  libexpat1-dev, expat,
  libxml2-utils,
  libusb-1.0-0-dev, zlib1g-dev,
  libshp-dev,
  qtbase5-dev,
- qtwebengine5-dev [amd64 arm64 armhf i386 mipsel],
+ qtwebengine5-dev [amd64 arm64 armhf i386 mips64el mipsel],
  qttools5-dev-tools,
+ libqt5serialport5-dev,
+ qttranslations5-l10n,
  imagemagick,
  locales-all,
  xsltproc,
  docbook-xsl
 Build-Depends-Indep: fop, docbook-xml, libpaper-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
-Homepage: http://www.gpsbabel.org/
+Homepage: https://www.gpsbabel.org/
 Vcs-Git: https://salsa.debian.org/debian-gps-team/pkg-gpsbabel.git
 Vcs-Browser: https://salsa.debian.org/debian-gps-team/pkg-gpsbabel
 
@@ -41,17 +44,11 @@
  .
  Among others GPSBabel supports the following formats:
  .
- Cetus, CoPilot Flight Planner, CSV, Custom CSV, Delorme Street Atlas,
- Delorme Street Atlas 2004 Plus, Delorms GPS Log, Delorme routes,
- DNA, EasyGPS Binary, Fugawi, Garmin serial, Geocaching.com loc,
- GeocachingDB, Geoniche, GPilotS, GPSDrive, GPSman, GPSPilot,
- gpsutil, GPX, Holux, IGC, Magellan serial, Magellan SD,
- Magellan Navigator Companion, Mapopolis.Com Mapconverter, Mapsend,
- Mapsource, Maptech, Microsoft Streets and Trips, Navicache,
- Netstumbler, NIMA/GNIS Geographic Names, NMEA sentences, OziExplorer,
- PalmDoc, PCX5, PocketStreets 2002 Pushpin, PSITrex, Quovadis,
- Tab-separated data, Tiger, TopoMapPro, Topo by National Geographic,
- xcsv, xmap, xmapwpt.
+ CSV, Custom CSV DNA, EasyGPS Binary, Fugawi, Garmin serial, Geocaching.com
+ loc, GPSDrive, GPX, Holux, IGC, Magellan serial, Magellan SD, Mapopolis.Com
+ Mapconverter, Mapsource, Maptech, Microsoft Streets and Trips, NIMA/GNIS
+ Geographic Names, NMEA sentences, OziExplorer, Tab-separated data, Topo by
+ National Geographic, xcsv
 
 Package: gpsbabel-doc
 Architecture: all
@@ -74,8 +71,9 @@
  This package contains the detailed documentation of gpsbabel.
 
 Package: gpsbabel-gui
-Architecture: amd64 arm64 armhf i386 mipsel
-Depends: ${shlibs:Depends}, ${misc:Depends}, gpsbabel (= ${binary:Version})
+Architecture: amd64 arm64 armhf i386 mips64el mipsel
+Depends: ${shlibs:Depends}, ${misc:Depends}, gpsbabel (= ${binary:Version}), gpsbabel-doc (= ${source:Version})
+Recommends: qttranslations5-l10n
 Description: GPS file conversion plus transfer to/from GPS units - GUI
  GPSBabel converts waypoints, tracks, and routes from one format to
  another, whether that format is a common mapping format like Delorme,
